/* 
 * File:   MAX7219.h
 * Author: arne
 *
 * Created on 15 de Outubro de 2022, 13:02
 */

#ifndef MAX7219_H
#define	MAX7219_H

//******************************************************************************
// Definições importantes do módulo
//******************************************************************************
#define NUM_MAX7219         1       // número de dispositivos
#define VEL                 14000   // valor do delay

//******************************************************************************
// Registradores
#define NO_OP_REG           0x00     
#define DECODE_MODE_REG     0x09
#define INTESITY_REG        0x0A
#define SCAN_LIMIT_REG      0x0B
#define SHUTDOWN_REG        0x0C
#define DISPLAY_TEST_REG    0x0F

//******************************************************************************
// Comandos
#define DISABLE_DECODE      0x00     
#define BRIGHTNESS          0x05     // 
#define SCAN_ALL_DIGITS     0x07   
#define SHUTDOWN_MODE       0x00
#define NORMAL_OPERATION    0x01
#define DISABLE_TEST        0x00 

#define VERTICAL            0x00
#define HORIZONTAL          0x01

#define NORMAL              0x00
#define SCROLL              0x01

//******************************************************************************
// Protótipo das funções
//******************************************************************************
void MAX7219_init(void);
void MAX7219_clear(void);
void MAX7219_config(uint8_t ci);
void MAX7219_write(uint8_t regADD, uint8_t dado, uint8_t ci);
void MAX7219_NoOperation(void);
void MAX7219_displayText(char* text, uint8_t sentido);
void MAX7219_testMatrix(uint8_t myType);
void MAX7219_scrollCMatrix(char toScroll);
void MAX7219_scrollMMatrix(const char *toScroll);
void MAX7219_putChar(uint8_t posChar, uint8_t posBuffer);

#endif	/* MAX7219_H */

